## mysql-8.0 8.0.42

=== CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

MESSAGE(STATUS "Running cmake version ${CMAKE_VERSION}")

IF(WIN32)
  # Load policies. This is needed in order to parse the wmic version check.
  CMAKE_MINIMUM_REQUIRED(VERSION 3.5.1)
  EXECUTE_PROCESS(COMMAND wmic os get version
    OUTPUT_VARIABLE NT_RELEASE_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE WMIC_RESULT
    )
  IF(WMIC_RESULT EQUAL 0)
    STRING(REPLACE "\r" "" NT_RELEASE_VERSION "${NT_RELEASE_VERSION}")
    STRING(REPLACE "\n" "" NT_RELEASE_VERSION "${NT_RELEASE_VERSION}")
    STRING(REGEX MATCH "Version[ ]+([0-9\.]+)" V_NUM "${NT_RELEASE_VERSION}")
    MESSAGE(STATUS "NT_RELEASE_VERSION is ${NT_RELEASE_VERSION}")
    IF(CMAKE_MATCH_1)
      IF(CMAKE_MATCH_1 VERSION_LESS "10")
        MESSAGE(FATAL_ERROR
          "Need at least Windows Server 2016, or Windows 10, to build")
      ENDIF()
    ENDIF()
  ENDIF()
  IF(CMAKE_GENERATOR MATCHES "Visual Studio" AND CMAKE_GENERATOR MATCHES "2019")
    IF(CMAKE_VERSION MATCHES "MSVC")
      # It is the bundled version, ignore version check,
      # (although this seems to be buggy too).
    ELSE()
      # Bug in msbuild, install the latest in the 3.15 series as a workaround.
      # https://gitlab.kitware.com/cmake/cmake/issues/19303
      # custom commands are re-built every time
      CMAKE_MINIMUM_REQUIRED(VERSION 3.15.3)
    ENDIF()
  ENDIF()
ELSEIF(APPLE)
  IF(CMAKE_GENERATOR STREQUAL "Xcode")
    SET(APPLE_XCODE 1)
  ENDIF()
  # For macOS version >= 11 we need cmake 3.18
  # System libraries like
  #    /usr/lib/libresolv.dylib
  # are no longer present in the file system.
  # cmake >= 3.18 will look for .tbd files in the SDK instead
  # So we end up linking with:
  #    /Applications/Xcode.app/.../usr/lib/libresolv.tbd
  # cmake >= 3.19 will use the new build system by default for Xcode >= 12.x
  CMAKE_MINIMUM_REQUIRED(VERSION 3.19)
ELSEIF(UNIX)
  # This is currently minimum version on all supported platforms.
  IF(CMAKE_VERSION VERSION_LESS 3.11.2)
    # Default cmake is 2.8.12.2 on RedHat
    IF(EXISTS "/etc/redhat-release")
      MESSAGE(WARNING "Please use cmake3 rather than cmake on this platform")
      FIND_PROGRAM(MY_CMAKE3 cmake3 /bin /usr/bin /usr/local/bin)
      IF(MY_CMAKE3)
        MESSAGE(STATUS "Found ${MY_CMAKE3}")
      ELSE()
        MESSAGE(STATUS "Please install cmake3 (yum install cmake3)")
      ENDIF()
    ELSE()
      # On SunOS /opt/csw/bin/cmake is (most likely) too old.
      FIND_PROGRAM(MY_UNAME uname /bin /usr/bin /usr/local/bin /sbin)
      IF(MY_UNAME)
        EXECUTE_PROCESS(COMMAND uname -s OUTPUT_VARIABLE MY_HOST_SYSTEM_NAME)
        IF(MY_HOST_SYSTEM_NAME MATCHES "SunOS")
          FIND_PROGRAM(MY_CMAKE cmake /usr/bin
            NO_CMAKE_ENVIRONMENT_PATH
            NO_SYSTEM_ENVIRONMENT_PATH
            )
          IF(MY_CMAKE)
            MESSAGE(STATUS "Found ${MY_CMAKE}")
            EXECUTE_PROCESS(COMMAND ${MY_CMAKE} --version)
          ELSE()
            MESSAGE(STATUS "Please install /usr/bin/cmake ")
          ENDIF()
        ENDIF()
      ENDIF()
    ENDIF()
  ENDIF()
ENDIF()

# CMake 3.5 is needed for TARGET_SOURCES(... $<TARGET_OBJECTS:${LIB}_objlib>)
# CMake 3.7 is needed for VERSION_GREATER_EQUAL
# CMake 3.8 is needed for cxx_std_17
# CMake 3.10 is needed for the bundled abseil sources,
#       but 3.8.2 seems to work OK
# For the set of currently supported platforms, we can bump up to:
CMAKE_MINIMUM_REQUIRED(VERSION 3.11.2)

# Will set GIT_EXECUTABLE and GIT_FOUND
FIND_PACKAGE(Git)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

# First, decide about build type (debug or release)
# If cmake is invoked with -DCMAKE_BUILD_TYPE, 
# respect user wishes and do not (re)define CMAKE_BUILD_TYPE. If WITH_DEBUG
# is given, set CMAKE_BUILD_TYPE = Debug. Otherwise, use Relwithdebinfo.

IF(DEFINED CMAKE_BUILD_TYPE)
  SET(HAVE_CMAKE_BUILD_TYPE TRUE)
ENDIF()

OPTION(WITH_DEBUG "Use dbug/safemutex" OFF)
OPTION(CHECK_ERRMSG_FORMAT "Check printf format for English error messages" OFF)

# Use a default manufacturer if no manufacturer was identified.
SET(MANUFACTURER_DOCSTRING
  "Set the entity that appears as the manufacturer of packages that support a manufacturer field.")
IF(NOT DEFINED MANUFACTURER) 
  SET(MANUFACTURER "Built from Source" CACHE  STRING ${MANUFACTURER_DOCSTRING})
  MARK_AS_ADVANCED(MANUFACTURER)
ENDIF()


# MAX_INDEXES - Set the maximum number of indexes per table, default 64U
IF (NOT MAX_INDEXES)
  SET(MAX_INDEXES 64U)
ELSEIF(MAX_INDEXES MATCHES "^[0-9]+[Uu]?$")
  # MAX_INDEXES should be unsigned, so add the U suffix if it's missing.
  STRING(REGEX REPLACE "^([0-9]+).*$" "\\1U" MAX_INDEXES "${MAX_INDEXES}")
  MESSAGE(STATUS "Configuring with MAX_INDEXES = ${MAX_INDEXES}")
ELSE()
  MESSAGE(FATAL_ERROR "MAX_INDEXES should be an unsigned integer.")
ENDIF(NOT MAX_INDEXES)

IF(MAX_INDEXES GREATER 255)
  MESSAGE(FATAL_ERROR "MAX_INDEXES values greater than 255 is not supported!")
ELSEIF(MAX_INDEXES LESS 64)
  # Per documentation, ignore values less than 64 and use the default instead.
  MESSAGE(WARNING "MAX_INDEXES option ignored because it is less than 64.")
  SET(MAX_INDEXES 64U)
ENDIF()

# We choose to provide WITH_DEBUG as alias to standard CMAKE_BUILD_TYPE=Debug
# which turns out to be not trivial, as this involves synchronization 
# between CMAKE_BUILD_TYPE and WITH_DEBUG. Besides, we have to deal with cases
# where WITH_DEBUG is  reset from ON to OFF  and here we need to reset 
# CMAKE_BUILD_TYPE to either none or default RelWithDebInfo

SET(BUILDTYPE_DOCSTRING
 "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or
 CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel")

IF(WITH_DEBUG)
  SET(CMAKE_BUILD_TYPE "Debug" CACHE STRING ${BUILDTYPE_DOCSTRING} FORCE)
  SET(OLD_WITH_DEBUG 1 CACHE INTERNAL "" FORCE)
ELSEIF(NOT HAVE_CMAKE_BUILD_TYPE OR OLD_WITH_DEBUG)
  IF(CMAKE_BUILD_TYPE MATCHES "Debug" OR NOT HAVE_CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING 
       ${BUILDTYPE_DOCSTRING} FORCE)
  ENDIF()
  SET(OLD_WITH_DEBUG 0 CACHE INTERNAL "" FORCE)
ENDIF()

STRING(TOUPPER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_UPPER)

IF(CMAKE_GENERATOR MATCHES "Visual Studio [1-9][0-9].*" AND
   CMAKE_GENERATOR_TOOLSET STREQUAL "")
  # Switch to 64 bit toolset on Windows (32 bit is default).
  # This is recommended as the 32 bit linker will run into address space issues
  # and not exit for long time.
  SET(CMAKE_GENERATOR_TOOLSET "host=x64")
ENDIF()

# On Linux el6/el7 the default gcc is too old, see if devtoolset is installed.
# Same with SLES 12, look for gcc 7 there.
# We need to look for gcc before calling PROJECT below.
OPTION(FORCE_UNSUPPORTED_COMPILER "Disable compiler version checks" OFF)
MARK_AS_ADVANCED(WITHOUT_SERVER FORCE_UNSUPPORTED_COMPILER)

# Use 'uname -r' and 'rpm -qf /' to figure out host system.
# For Docker images we cannot trust uname, so use rpm instead.
IF(UNIX)
  FIND_PROGRAM(MY_UNAME uname /bin /usr/bin /usr/local/bin /sbin)
  IF(MY_UNAME)
    EXECUTE_PROCESS(COMMAND ${MY_UNAME} -s
      OUTPUT_VARIABLE MY_HOST_SYSTEM_NAME
      OUTPUT_STRIP_TRAILING_WHITESPACE
      RESULT_VARIABLE MY_UNAME_RESULT
      )
    EXECUTE_PROCESS(COMMAND ${MY_UNAME} -m
      OUTPUT_VARIABLE MY_HOST_MACHINE_NAME
      OUTPUT_STRIP_TRAILING_WHITESPACE
      RESULT_VARIABLE MY_UNAME_MACHINE_RESULT
      )
    EXECUTE_PROCESS(COMMAND ${MY_UNAME} -r
      OUTPUT_VARIABLE MY_HOST_SYSTEM_VERSION)
  ENDIF()
  FIND_PROGRAM(MY_DPKG_BUILDFLAGS dpkg-buildflags /bin /usr/bin)
  FIND_PROGRAM(MY_RPM rpm /bin /usr/bin)
  IF(MY_RPM)
    EXECUTE_PROCESS(COMMAND ${MY_RPM} -qf /
      OUTPUT_VARIABLE MY_HOST_FILESYSTEM_NAME
      OUTPUT_STRIP_TRAILING_WHITESPACE
      RESULT_VARIABLE MY_RPM_RESULT
      )
  ENDIF()
ENDIF()

# See comments above, about CMAKE_MINIMUM_REQUIRED VERSION and macOS 11.
IF(APPLE)
  IF(MY_HOST_SYSTEM_VERSION VERSION_GREATER_EQUAL 20)
    CMAKE_MINIMUM_REQUIRED(VERSION 3.18)
  ENDIF()
ENDIF()

# Add all policies *after* CMAKE_MINIMUM_REQUIRED
# Repeating CMAKE_MINIMUM_REQUIRED here will load defaults for 3.11.2
CMAKE_MINIMUM_REQUIRED(VERSION 3.11.2)
INCLUDE(cmake_policies NO_POLICY_SCOPE)

MACRO(STRING_APPEND STRING_VAR INPUT)
  SET(${STRING_VAR} "${${STRING_VAR}}${INPUT}")
ENDMACRO()

MACRO(STRING_PREPEND STRING_VAR INPUT)
  SET(${STRING_VAR} "${INPUT}${${STRING_VAR}}")
ENDMACRO()

IF(MY_HOST_SYSTEM_NAME MATCHES "SunOS")
  SET(SOLARIS 1)
ENDIF()

IF(MY_HOST_SYSTEM_NAME MATCHES "Linux")
  # Trust 'rpm -qf /' rather than 'uname -s'
  STRING(REGEX MATCH "\\.el([6789])\\." MATCH_FSYS "${MY_HOST_FILESYSTEM_NAME}")
  IF(NOT CMAKE_MATCH_1)
    STRING(REGEX MATCH "\\.el(10)\\." MATCH_FSYS "${MY_HOST_FILESYSTEM_NAME}")
  ENDIF()

  # Set LINUX_RHEL6, LINUX_RHEL7, LINUX_RHEL8 or LINUX_RHEL9 or LINUX_RHEL10
  IF(CMAKE_MATCH_1)
    SET(LINUX_RHEL 1)
    SET(LINUX_RHEL${CMAKE_MATCH_1} 1)
  ENDIF()
ENDIF()

IF(NOT LINUX_RHEL AND MY_HOST_SYSTEM_NAME MATCHES "Linux")
  IF(EXISTS "/etc/os-release")
    FILE(READ "/etc/os-release" MY_OS_RELEASE)
    IF(MY_OS_RELEASE MATCHES "Debian")
      SET(LINUX_DEBIAN 1)
    ELSEIF(MY_OS_RELEASE MATCHES "Ubuntu")
      SET(LINUX_UBUNTU 1)
      IF(MY_OS_RELEASE MATCHES "16.04")
        SET(LINUX_UBUNTU_16_04 1)
      ELSEIF(MY_OS_RELEASE MATCHES "18.04")
        SET(LINUX_UBUNTU_18_04 1)
      ENDIF()
      # /etc/os-release contains a line like
      # VERSION_ID="20.04"
      # Match the numeric value, including the dot, ignore the rest:
      STRING(REGEX MATCH
        "VERSION_ID=\"([0-9\\.]+).*" UNUSED ${MY_OS_RELEASE})
      IF(CMAKE_MATCH_1)
        SET(LINUX_UBUNTU_VERSION_ID ${CMAKE_MATCH_1})
      ENDIF()
    ENDIF()
  ENDIF()
ENDIF()

IF(EXISTS "/etc/SuSE-release")
  SET(LINUX_SUSE 1)
ENDIF()

IF(LINUX_SUSE)
  FILE(READ "/etc/SuSE-release" MY_OS_RELEASE)
  IF(MY_OS_RELEASE MATCHES "SUSE Linux Enterprise Server 12")
    SET(LINUX_SUSE_12 1)
  ELSEIF(MY_OS_RELEASE MATCHES "SUSE Linux Enterprise Server 15" OR
      MY_OS_RELEASE MATCHES "openSUSE .* 15")
    SET(LINUX_SUSE_15 1)
  ELSE()
    MESSAGE(WARNING "Unknown SUSE version.")
  ENDIF()
ENDIF()

# In case we pick up values form the CACHE or from the command line.
# See invokation of ADD_LINUX_RPM_FLAGS below.
SET(INITIAL_CMAKE_C_FLAGS)
SET(INITIAL_CMAKE_CXX_FLAGS)
IF(DEFINED CMAKE_C_FLAGS)
  SET(INITIAL_CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
ENDIF()
IF(DEFINED CMAKE_CXX_FLAGS)
  SET(INITIAL_CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
ENDIF()

IF(CMAKE_HOST_UNIX AND NOT FORCE_UNSUPPORTED_COMPILER
    AND NOT CMAKE_C_COMPILER AND NOT CMAKE_CXX_COMPILER)
  # Cannot INCLUDE(CMakeDetermineSystem) prior to PROJECT initialization below.
  SET (ENV_CC "$ENV{CC}")
  SET (ENV_CXX "$ENV{CXX}")
  IF (ENV_CC STREQUAL "" AND ENV_CXX STREQUAL "")
    IF(LINUX_RHEL)
      MESSAGE(STATUS "This is ${MATCH_FSYS} as found from 'rpm -qf /'")
    ENDIF()

=== libservices/CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

IF(WITHOUT_SERVER)
  MESSAGE(STATUS "The mysqlservices library is for server plugins only")
  RETURN()
ENDIF()

ADD_WSHADOW_WARNING()

SET(MYSQLSERVICES_SOURCES
  service_command.c
  locking_service.c
  srv_session_service.c
  thd_alloc_service.c
  thd_wait_service.c
  my_plugin_log_service.c
  my_thread_scheduler_service.c
  mysql_string_service.c
  mysql_malloc_service.c
  mysql_password_policy_service.c
  parser_service.c
  srv_session_info_service.c
  rpl_transaction_ctx_service.c
  rpl_transaction_write_set_service.c
  security_context_service.c
  mysql_keyring_service.c
  plugin_registry_service.c)

ADD_LIBRARY(mysqlservices STATIC ${MYSQLSERVICES_SOURCES})
IF(INSTALL_STATIC_LIBRARIES)
  INSTALL(TARGETS mysqlservices
    DESTINATION ${INSTALL_LIBDIR} COMPONENT Development)
ENDIF()

=== man/CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

# Copy man pages
SET(MAN1
  comp_err.1
  ibd2sdi.1
  innochecksum.1
  lz4_decompress.1
  my_print_defaults.1
  myisam_ftdump.1
  myisamchk.1
  myisamlog.1
  myisampack.1
  mysql.1
  mysql_config.1
  mysql_config_editor.1
  mysql_secure_installation.1
  mysql_ssl_rsa_setup.1
  mysql_tzinfo_to_sql.1
  mysql_upgrade.1
  mysqladmin.1
  mysqlbinlog.1
  mysqlcheck.1
  mysqldump.1
  mysqldumpslow.1
  mysqlimport.1
  mysqlman.1
  mysqlpump.1
  mysqlshow.1
  mysqlslap.1
  perror.1
  zlib_decompress.1
  )

IF(NOT WITH_SYSTEMD)
  LIST(APPEND MAN1
    mysql.server.1
    mysqld_multi.1
    mysqld_safe.1
  )
ENDIF()

SET(MAN1_NDB
  ndb_blob_tool.1
  ndb_config.1
  ndb_cpcd.1
  ndb_delete_all.1
  ndb_desc.1
  ndb_drop_index.1
  ndb_drop_table.1
  ndb_error_reporter.1
  ndb_import.1
  ndb_index_stat.1
  ndb_mgm.1
  ndb_move_data.1
  ndb_perror.1
  ndb_print_backup_file.1
  ndb_print_file.1
  ndb_print_frag_file.1
  ndb_print_schema_file.1
  ndb_print_sys_file.1
  ndb_redo_log_reader.1
  ndb_restore.1
  ndb_secretsfile_reader.1
  ndb_select_all.1
  ndb_select_count.1
  ndb_show_tables.1
  ndb_size.pl.1
  ndb_top.1
  ndb_waiter.1
  ndbinfo_select_all.1
  ndbxfrm.1
)
SET(MAN1_ROUTER
  mysqlrouter.1
  mysqlrouter_passwd.1
  mysqlrouter_plugin_info.1
)
SET(MAN8
  mysqld.8
  )
SET(MAN8_NDB
  ndb_mgmd.8
  ndbd.8
  ndbmtd.8
)

INSTALL(FILES ${MAN1} DESTINATION ${INSTALL_MANDIR}/man1 COMPONENT ManPages)
INSTALL(FILES ${MAN8} DESTINATION ${INSTALL_MANDIR}/man8 COMPONENT ManPages)

IF(WITH_ROUTER)
  INSTALL(FILES ${MAN1_ROUTER}
    DESTINATION ${INSTALL_MANDIR}/man1 COMPONENT ManPages
    )
ENDIF()

IF(WITH_NDB)
  INSTALL(FILES ${MAN1_NDB}
    DESTINATION ${INSTALL_MANDIR}/man1 COMPONENT ManPages)
  INSTALL(FILES ${MAN8_NDB}
    DESTINATION ${INSTALL_MANDIR}/man8 COMPONENT ManPages)
ENDIF()

=== scripts/CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

DISABLE_MISSING_PROFILE_WARNING()

ADD_SUBDIRECTORY(sys_schema)

MYSQL_ADD_EXECUTABLE(comp_sql comp_sql.cc SKIP_INSTALL)

# Add compiler information, for easier debugging of output from mysql_config.
SET(COMPILER_ID_AND_VERSION
  "${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")

# Build mysql_fix_privilege_tables.sql (concatenate 2 sql scripts)
IF(NOT WIN32 OR CMAKE_CROSSCOMPILING)
  FIND_PROGRAM(CAT_EXECUTABLE cat DOC "path to the executable")
  MARK_AS_ADVANCED(CAT_EXECUTABLE)
ENDIF()

IF(CAT_EXECUTABLE)
  SET(CAT_COMMAND COMMAND
    ${CMAKE_COMMAND} -E chdir  ${CMAKE_CURRENT_SOURCE_DIR}
    ${CAT_EXECUTABLE} mysql_system_tables.sql mysql_system_tables_fix.sql >
    ${CMAKE_CURRENT_BINARY_DIR}/mysql_fix_privilege_tables.sql
  )
ELSEIF(WIN32)
  FILE(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR}/mysql_fix_privilege_tables.sql
    native_outfile )
  SET(CAT_COMMAND
    COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_CURRENT_SOURCE_DIR}
    cmd /c copy /b mysql_system_tables.sql + mysql_system_tables_fix.sql
    ${native_outfile} )
ELSE()
  MESSAGE(FATAL_ERROR "Cannot concatenate files")
ENDIF()

# Build mysql_fix_privilege_tables.h
ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/mysql_fix_privilege_tables_sql.h
  ${CAT_COMMAND}
  COMMAND comp_sql
  mysql_fix_privilege_tables
  mysql_fix_privilege_tables.sql
  mysql_fix_privilege_tables_sql.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables.sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables_fix.sql
)

# Add target for the above to be built
MY_ADD_CUSTOM_TARGET(GenFixPrivs
  ALL
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/mysql_fix_privilege_tables_sql.h
)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_sys_schema.h
  COMMAND comp_sql
  mysql_sys_schema
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_sys_schema.sql
  sql_commands_sys_schema.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_sys_schema.sql
  )

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_system_data.h
  COMMAND comp_sql
  mysql_system_data
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables_data.sql
  sql_commands_system_data.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables_data.sql
)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_system_tables_data_fix.h
  COMMAND comp_sql
  mysql_system_tables_data_fix
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables_data_fix.sql
  sql_commands_system_tables_data_fix.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables_data_fix.sql
)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_system_tables.h
  COMMAND comp_sql
  mysql_system_tables
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables.sql
  sql_commands_system_tables.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables.sql
)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_system_users.h
  COMMAND comp_sql
  mysql_system_users
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_users.sql
  sql_commands_system_users.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_users.sql
)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_help_data.h
  COMMAND comp_sql
  fill_help_tables
  ${CMAKE_CURRENT_SOURCE_DIR}/fill_help_tables.sql
  sql_commands_help_data.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql
  ${CMAKE_CURRENT_SOURCE_DIR}/fill_help_tables.sql
)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sql_firewall_stored_procedures.h
  COMMAND comp_sql
  firewall_stored_procedures
  ${CMAKE_CURRENT_SOURCE_DIR}/firewall_stored_procedures.sql
  sql_firewall_stored_procedures.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql
  ${CMAKE_CURRENT_SOURCE_DIR}/firewall_stored_procedures.sql
)

# Add target for the above to be built
IF(NOT WITHOUT_SERVER)
  MY_ADD_CUSTOM_TARGET(GenBootstrapPriv
    ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_system_data.h
    ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_system_tables.h
    ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_system_users.h
    ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_help_data.h
    ${CMAKE_CURRENT_BINARY_DIR}/sql_commands_system_tables_data_fix.h
    ${CMAKE_CURRENT_BINARY_DIR}/sql_firewall_stored_procedures.h
  )
ENDIF()

IF(UNIX)
  FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/make_binary_distribution
    "cd ${CMAKE_BINARY_DIR} && '${CMAKE_CPACK_COMMAND}' -G TGZ --config CPackConfig.cmake\n" )
  EXECUTE_PROCESS(
    COMMAND chmod +x ${CMAKE_CURRENT_BINARY_DIR}/make_binary_distribution
)
ENDIF()

SET(COMPILE_DEFINITIONS_WHITELIST
)

# In practice: only in use on Solaris
SET(CMAKE_C_FLAGS_WHITELIST
  "-m32"
  "-m64"
)

SET(CFLAGS "")
SET(CXXFLAGS "")

GET_PROPERTY(cwd_definitions DIRECTORY PROPERTY COMPILE_DEFINITIONS)
FOREACH(white_flag ${COMPILE_DEFINITIONS_WHITELIST})
  FOREACH(flag ${cwd_definitions})
    IF (${flag} MATCHES ${white_flag})
      SET(CFLAGS "-D${white_flag} ${CFLAGS}")
      SET(CXXFLAGS "-D${white_flag} ${CXXFLAGS}")
    ENDIF()
  ENDFOREACH()
ENDFOREACH()

IF(CMAKE_BUILD_TYPE AND BUILD_IS_SINGLE_CONFIG)
  SET(CMAKEBT_FLAGS
    "${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE_UPPER}} ${CMAKE_C_FLAGS}")
  SEPARATE_ARGUMENTS(CMAKEBT_FLAGS)
ENDIF()

FOREACH(white_flag ${CMAKE_C_FLAGS_WHITELIST})
  FOREACH(flag ${CMAKEBT_FLAGS})
    IF (${flag} STREQUAL ${white_flag})
      SET(CFLAGS "${white_flag} ${CFLAGS}")
      SET(CXXFLAGS "${white_flag} ${CXXFLAGS}")
    ENDIF()
  ENDFOREACH()
ENDFOREACH()

# Do not remove -std=c++14 for Oracle Studio as it is required to get
# the correct libraries. Only remove for GCC/Clang
IF(MY_COMPILER_IS_GNU_OR_CLANG)
  STRING(REGEX REPLACE "-std=c..[0-9]+" "" CXXFLAGS "${CXXFLAGS}")
ENDIF()

IF(FREEBSD)
  SET (PERL_PATH "/usr/local/bin/perl")
ELSE()
  SET (PERL_PATH "/usr/bin/perl")
ENDIF()

IF(UNIX)
  # SHELL_PATH, FIND_PROC, CHECK_PID are used by mysqld_safe
  IF(SOLARIS)
    SET (SHELL_PATH "/bin/bash")
  ELSE()
    SET (SHELL_PATH "/bin/sh")
  ENDIF()

  IF(LINUX)
    SET (FIND_PROC
      "ps wwwp $PID | grep -v mysqld_safe | grep -- $MYSQLD > /dev/null")
  ENDIF()
  IF(SOLARIS)
    SET (FIND_PROC
      "ps -p $PID | grep -v mysqld_safe | grep -- $MYSQLD > /dev/null")
  ENDIF()

  IF(NOT FIND_PROC)
    # BSD style
    EXECUTE_PROCESS(COMMAND ps -uaxww
      OUTPUT_QUIET ERROR_QUIET RESULT_VARIABLE result)
    IF(result MATCHES 0)
      SET( FIND_PROC
        "ps -uaxww | grep -v mysqld_safe | grep -- $MYSQLD | grep $PID > /dev/null")
    ENDIF()
  ENDIF()

  IF(NOT FIND_PROC)
    # SysV style
    EXECUTE_PROCESS(COMMAND ps -ef
      OUTPUT_QUIET ERROR_QUIET RESULT_VARIABLE result)
    IF(result MATCHES 0)
      SET( FIND_PROC "ps -ef | grep -v mysqld_safe | grep -- $MYSQLD | grep $PID > /dev/null")
    ENDIF()
  ENDIF()

  EXECUTE_PROCESS(COMMAND sh -c "kill -0 $$"
    OUTPUT_QUIET ERROR_QUIET RESULT_VARIABLE result)
  IF(result MATCHES 0)
    SET(CHECK_PID "kill -0 $PID > /dev/null 2> /dev/null")
  ELSE()
    SET(CHECK_PID "kill -s SIGCONT $PID  > /dev/null 2> /dev/null")
  ENDIF()

  SET(MYSQLD_USER "mysql")
  SET(MYSQLROUTER_USER "mysqlrouter")

ENDIF(UNIX)

SET(prefix "${CMAKE_INSTALL_PREFIX}")
SET(sysconfdir ${prefix})
SET(bindir ${prefix}/${INSTALL_BINDIR})
SET(libexecdir ${prefix}/${INSTALL_SBINDIR})
SET(datadir ${prefix}/${INSTALL_MYSQLSHAREDIR})
SET(libsubdir  ${INSTALL_LIBDIR})
SET(pkgincludedir ${prefix}/${INSTALL_INCLUDEDIR})
SET(pkglibdir ${prefix}/${INSTALL_LIBDIR})
SET(pkgplugindir ${prefix}/${INSTALL_PLUGINDIR})
SET(localstatedir ${MYSQL_DATADIR})

IF(SOLARIS)
  SET(RPATH_OPTION " -R$pkglibdir")
ENDIF()

IF(LINUX_INSTALL_RPATH_ORIGIN)
  SET(RPATH_OPTION " -Wl,-R,$pkglibdir")    # for mysql_config
  SET(RPATH_OPTION_PC " -Wl,-R,\${libdir}") # for pkg_config
  # Do not use STRING_APPEND, it may eval the $.
  SET(RPATH_OPTION "${RPATH_OPTION} -L$pkglibdir/private")
  SET(RPATH_OPTION_PC "${RPATH_OPTION_PC} -L\${libdir}/private")
  SET(RPATH_OPTION "${RPATH_OPTION} -Wl,-R,$pkglibdir/private")
  SET(RPATH_OPTION_PC "${RPATH_OPTION_PC} -Wl,-R,\${libdir}/private")
ENDIF()

# some scripts use  @TARGET_LINUX@
IF(LINUX)
  SET(TARGET_LINUX "true")
ELSE()
  SET(TARGET_LINUX "false")
ENDIF()

# Use cmake variables to inspect dependencies for
# mysqlclient library (add -l stuff)
SET(CLIENT_LIBS "")
SET(LIBS "")

# Extract dependencies using CMake's LINK_LIBRARIES property.
# Returned string in ${var} is can be passed to linker's command line
MACRO(EXTRACT_LINK_LIBRARIES target var)
  GET_TARGET_PROPERTY(TARGET_LIB_DEPENDS ${target} LINK_LIBRARIES)
  # Uncomment to debug:
  # MESSAGE(STATUS "xxx ${target} ${TARGET_LIB_DEPENDS}")
  # Depending on platform, and whether "system" or "bundled" has been used,
  # this will typically be:
  # ext::zlib  ext::zstd  <ssl>  <crypto>  /usr/lib64/libresolv.so  m
  IF(TARGET_LIB_DEPENDS)
    LIST(REMOVE_DUPLICATES TARGET_LIB_DEPENDS)
    FOREACH(lib ${TARGET_LIB_DEPENDS})
      IF (lib MATCHES "^\\-l")
        SET(${var} "${${var}} ${lib} ")
      ELSEIF (lib MATCHES "^ext::")
        STRING(REGEX MATCH "ext::([a-z]+)" MATCH_LIB "${lib}")
        SET(SYSTEM_LIB ${CMAKE_MATCH_1})
        SET(SYSTEM_LINK_FLAG ${${SYSTEM_LIB}_SYSTEM_LINK_FLAGS})
        IF(NOT SYSTEM_LINK_FLAG)
          MESSAGE(WARNING "Missing link flag for ${lib}")
        ELSE()
          SET(${var} "${${var}} ${SYSTEM_LINK_FLAG} ")
        ENDIF()
      ELSEIF (lib MATCHES "^\\-L")
        # Search directory. Test on FreeBSD: -L/usr/local/lib -lunwind
        SET(${var} "${${var}} ${lib} ")
      ELSEIF(lib MATCHES "^/")
        # Full path, convert to just filename, strip "lib" prefix and extension
        GET_FILENAME_COMPONENT(dir "${lib}" DIRECTORY)
        GET_FILENAME_COMPONENT(lib "${lib}" NAME_WE)
        STRING(REGEX REPLACE "^lib" "" lib "${lib}")
        # Add -L/usr/local/opt/openssl/lib for ssl (and crypto).
        IF(APPLE AND WITH_SSL STREQUAL "system" AND ${lib} STREQUAL "ssl")
          SET(${var} "${${var}}-L${dir} " )
        ENDIF()
        # Add -L/usr/local/lib for zstd
        IF(APPLE AND WITH_ZSTD STREQUAL "system" AND ${lib} STREQUAL "zstd")
          SET(${var} "${${var}}-L${dir} " )
        ENDIF()
        SET(${var} "${${var}}-l${lib} " )
      ELSE()
        SET(${var} "${${var}}-l${lib} " )
      ENDIF()
    ENDFOREACH()
  ENDIF()
  IF(MSVC)
    STRING(REPLACE "-l" "" ${var} "${${var}}")
  ENDIF()
  STRING(REGEX REPLACE "^[ ]+" "" ${var} "${${var}}")
  STRING(REGEX REPLACE "[ ]+$" "" ${var} "${${var}}")
ENDMACRO()

=== sql/CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

INCLUDE_DIRECTORIES(SYSTEM ${BOOST_PATCHES_DIR} ${BOOST_INCLUDE_DIR})

ADD_WSHADOW_WARNING()

# Lots of warnings about -Walloc-size-larger-than= from my_malloc.cc
# but it is basically impossible to trace the actual origin.

IF(FPROFILE_GENERATE OR FPROFILE_USE OR
    CMAKE_COMPILER_FLAG_WITH_LTO OR WITH_LTO)
  IF(MY_COMPILER_IS_GNU AND NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 10)
    # -Walloc-size-larger-than=PTRDIFF_MAX is enabled by default.
    STRING_APPEND(CMAKE_EXE_LINKER_FLAGS " -Wno-alloc-size-larger-than")
    # In functions generated by protobuf:
    STRING_APPEND(CMAKE_EXE_LINKER_FLAGS " -Wno-stringop-overflow")
  ENDIF()
ENDIF()

# Array indexing with pland_idx == int8 gives warnings.
IF(SOLARIS AND MY_COMPILER_IS_GNU_OR_CLANG)
  ADD_COMPILE_OPTIONS("-Wno-char-subscripts")
ENDIF()

SET(CONF_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/sql_builtin.cc
)
SET(GEN_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/sql_yacc.h
  ${CMAKE_CURRENT_BINARY_DIR}/sql_yacc.cc
  ${CMAKE_CURRENT_BINARY_DIR}/sql_hints.yy.h
  ${CMAKE_CURRENT_BINARY_DIR}/sql_hints.yy.cc
  ${CMAKE_CURRENT_BINARY_DIR}/lex_hash.h
)
SET(GEN_DIGEST_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/lex_token.h
)
SET(GEN_KEYWORD_LIST_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/keyword_list.h
)

SET_SOURCE_FILES_PROPERTIES(
  ${GEN_SOURCES}
  ${GEN_DIGEST_SOURCES}
  ${GEN_KEYWORD_LIST_SOURCES}
  ${CONF_SOURCES}
  PROPERTIES GENERATED 1)

# Gen_lex_token
# Make sure sql_yacc.h is generated before compiling gen_lex_token
MYSQL_ADD_EXECUTABLE(gen_lex_token
  gen_lex_token.cc
  DEPENDENCIES GenServerSource
  SKIP_INSTALL
  )

MY_CHECK_CXX_COMPILER_WARNING("-Wmissing-profile" HAS_MISSING_PROFILE)
IF(HAS_MISSING_PROFILE)
  ADD_COMPILE_FLAGS(
    binlog_reader.cc  # In case we did not profile replication.
    gen_lex_token.cc  # This is a compile-time tool.
    COMPILE_FLAGS ${HAS_MISSING_PROFILE})
ENDIF()

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/lex_token.h
  COMMAND gen_lex_token > lex_token.h
  DEPENDS gen_lex_token
)

# gen_keyword_list
# Make sure sql_yacc.h is generated before compiling gen_keyword_list
MYSQL_ADD_EXECUTABLE(gen_keyword_list
  gen_keyword_list.cc
  DEPENDENCIES GenServerSource
  LINK_LIBRARIES ext::icu
  SKIP_INSTALL
  )

IF(WITH_LTO OR CMAKE_COMPILER_FLAG_WITH_LTO)
  TARGET_COMPILE_OPTIONS(gen_keyword_list PRIVATE "-fno-lto")
ENDIF()

IF(HAS_MISSING_PROFILE)
  ADD_COMPILE_FLAGS(gen_keyword_list.cc COMPILE_FLAGS ${HAS_MISSING_PROFILE})
ENDIF()

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/keyword_list.h
  COMMAND gen_keyword_list ${CMAKE_CURRENT_SOURCE_DIR}/sql_yacc.yy > ${CMAKE_CURRENT_BINARY_DIR}/keyword_list.h
  DEPENDS gen_keyword_list
)

ADD_DEFINITIONS(-DMYSQL_SERVER)
ADD_SUBDIRECTORY(server_component)
ADD_SUBDIRECTORY(protobuf)

SET(DD_SOURCES
  dd/collection.cc
  dd/dd_event.cc
  dd/dd_resource_group.cc
  dd/dd_routine.cc
  dd/dd_schema.cc
  dd/dd_table.cc
  dd/dd_tablespace.cc
  dd/dd_trigger.cc
  dd/dd_view.cc
  dd/dd_utility.cc
  dd/properties.cc

  dd/impl/dd.cc
  dd/impl/dictionary_impl.cc
  dd/impl/properties_impl.cc
  dd/impl/system_registry.cc
  dd/impl/transaction_impl.cc
  dd/impl/utils.cc
  dd/impl/sdi.cc
  dd/impl/sdi_api.cc
  dd/impl/sdi_file.cc
  dd/impl/sdi_tablespace.cc
  dd/impl/string_type.cc

  dd/impl/bootstrap/bootstrap_ctx.cc
  dd/impl/bootstrap/bootstrapper.cc

  dd/impl/cache/dictionary_client.cc
  dd/impl/cache/local_multi_map.cc
  dd/impl/cache/multi_map_base.cc
  dd/impl/cache/shared_multi_map.cc
  dd/impl/cache/shared_dictionary_cache.cc
  dd/impl/cache/storage_adapter.cc

  dd/impl/raw/object_keys.cc
  dd/impl/raw/raw_record.cc
  dd/impl/raw/raw_record_set.cc
  dd/impl/raw/raw_table.cc

  dd/impl/system_views/administrable_role_authorizations.cc
  dd/impl/system_views/applicable_roles.cc
  dd/impl/system_views/character_sets.cc
  dd/impl/system_views/check_constraints.cc
  dd/impl/system_views/collations.cc
  dd/impl/system_views/collation_charset_applicability.cc
  dd/impl/system_views/columns.cc
  dd/impl/system_views/columns_extensions.cc
  dd/impl/system_views/column_statistics.cc
  dd/impl/system_views/enabled_roles.cc
  dd/impl/system_views/events.cc
  dd/impl/system_views/files.cc
  dd/impl/system_views/innodb_datafiles.cc
  dd/impl/system_views/innodb_foreign.cc
  dd/impl/system_views/innodb_foreign_cols.cc
  dd/impl/system_views/innodb_fields.cc
  dd/impl/system_views/innodb_tablespaces_brief.cc
  dd/impl/system_views/key_column_usage.cc
  dd/impl/system_views/keywords.cc
  dd/impl/system_views/parameters.cc
  dd/impl/system_views/partitions.cc
  dd/impl/system_views/referential_constraints.cc
  dd/impl/system_views/resource_groups.cc
  dd/impl/system_views/role_column_grants.cc
  dd/impl/system_views/role_routine_grants.cc
  dd/impl/system_views/role_table_grants.cc
  dd/impl/system_views/routines.cc
  dd/impl/system_views/schemata.cc
  dd/impl/system_views/schemata_extensions.cc
  dd/impl/system_views/statistics.cc
  dd/impl/system_views/st_spatial_reference_systems.cc
  dd/impl/system_views/st_units_of_measure.cc
  dd/impl/system_views/st_geometry_columns.cc
  dd/impl/system_views/tables.cc
  dd/impl/system_views/tables_extensions.cc
  dd/impl/system_views/table_constraints.cc
  dd/impl/system_views/table_constraints_extensions.cc
  dd/impl/system_views/tablespaces_extensions.cc
  dd/impl/system_views/triggers.cc
  dd/impl/system_views/view_routine_usage.cc
  dd/impl/system_views/view_table_usage.cc
  dd/impl/system_views/views.cc
  dd/impl/system_views/user_attributes.cc

  dd/impl/tables/character_sets.cc
  dd/impl/tables/check_constraints.cc
  dd/impl/tables/collations.cc
  dd/impl/tables/columns.cc
  dd/impl/tables/column_statistics.cc
  dd/impl/tables/column_type_elements.cc
  dd/impl/tables/dd_properties.cc
  dd/impl/tables/events.cc
  dd/impl/tables/foreign_key_column_usage.cc
  dd/impl/tables/foreign_keys.cc
  dd/impl/tables/index_column_usage.cc
  dd/impl/tables/indexes.cc
  dd/impl/tables/index_partitions.cc
  dd/impl/tables/index_stats.cc
  dd/impl/tables/parameters.cc
  dd/impl/tables/parameter_type_elements.cc
  dd/impl/tables/resource_groups.cc
  dd/impl/tables/routines.cc
  dd/impl/tables/schemata.cc
  dd/impl/tables/spatial_reference_systems.cc
  dd/impl/tables/table_partitions.cc
  dd/impl/tables/table_stats.cc
  dd/impl/tables/table_partition_values.cc
  dd/impl/tables/tables.cc
  dd/impl/tables/tablespace_files.cc
  dd/impl/tables/tablespaces.cc
  dd/impl/tables/triggers.cc
  dd/impl/tables/view_routine_usage.cc
  dd/impl/tables/view_table_usage.cc

  dd/impl/types/index_stat_impl.cc
  dd/impl/types/table_stat_impl.cc
  dd/impl/types/abstract_table_impl.cc
  dd/impl/types/charset_impl.cc
  dd/impl/types/check_constraint_impl.cc
  dd/impl/types/collation_impl.cc
  dd/impl/types/column_impl.cc
  dd/impl/types/column_statistics_impl.cc
  dd/impl/types/column_type_element_impl.cc
  dd/impl/types/entity_object_table_impl.cc
  dd/impl/types/entity_object_impl.cc
  dd/impl/types/event_impl.cc
  dd/impl/types/foreign_key_element_impl.cc
  dd/impl/types/foreign_key_impl.cc
  dd/impl/types/function_impl.cc
  dd/impl/types/index_element_impl.cc
  dd/impl/types/index_impl.cc
  dd/impl/types/object_table_impl.cc
  dd/impl/types/object_table_definition_impl.cc
  dd/impl/types/parameter_impl.cc
  dd/impl/types/parameter_type_element_impl.cc
  dd/impl/types/partition_impl.cc
  dd/impl/types/partition_index_impl.cc
  dd/impl/types/partition_value_impl.cc
  dd/impl/types/procedure_impl.cc
  dd/impl/types/resource_group_impl.cc
  dd/impl/types/routine_impl.cc
  dd/impl/types/schema_impl.cc
  dd/impl/types/spatial_reference_system_impl.cc
  dd/impl/types/table_impl.cc
  dd/impl/types/tablespace_file_impl.cc
  dd/impl/types/tablespace_impl.cc
  dd/impl/types/trigger_impl.cc
  dd/impl/types/view_impl.cc
  dd/impl/types/view_routine_impl.cc
  dd/impl/types/view_table_impl.cc
  dd/impl/types/weak_object_impl.cc

  dd/impl/upgrade/server.cc
  dd/impl/upgrade/dd.cc

  dd/info_schema/metadata.cc
  dd/info_schema/show.cc
  dd/info_schema/show_query_builder.cc
  dd/info_schema/table_stats.cc
  dd/info_schema/tablespace_stats.cc

  dd/performance_schema/init.cc

  dd/ndbinfo_schema/init.cc

  dd/upgrade_57/event.cc
  dd/upgrade_57/global.cc
  dd/upgrade_57/routine.cc
  dd/upgrade_57/schema.cc
  dd/upgrade_57/table.cc
  dd/upgrade_57/upgrade.cc
)

SET(SQL_GIS_SOURCES
  gis/area.cc
  gis/buffer.cc
  gis/covered_by.cc
  gis/crosses.cc
  gis/difference.cc
  gis/difference_functor.cc
  gis/disjoint.cc
  gis/distance.cc
  gis/distance_functor.cc
  gis/distance_sphere.cc
  gis/equals.cc
  gis/frechet_distance.cc
  gis/gc_utils.cc
  gis/geometries.cc
  gis/hausdorff_distance.cc
  gis/intersection.cc
  gis/intersection_functor.cc
  gis/intersects.cc
  gis/is_simple.cc
  gis/is_valid.cc
  gis/length.cc
  gis/line_interpolate.cc
  gis/mbr_utils.cc
  gis/overlaps.cc
  gis/ring_flip_visitor.cc
  gis/rtree_support.cc
  gis/simplify.cc
  gis/so_utils.cc
  gis/srs/srs.cc
  gis/srs/wkt_parser.cc
  gis/st_units_of_measure.cc
  gis/symdifference.cc
  gis/symdifference_functor.cc
  gis/touches.cc
  gis/transform.cc
  gis/union.cc
  gis/union_functor.cc
  gis/within.cc
  gis/wkb.cc
  gis/wkb_size_visitor.cc
  gis/wkb_visitor.cc
  item_geofunc.cc
  item_geofunc_buffer.cc
  item_geofunc_internal.cc
  item_geofunc_relchecks.cc
  options_parser.cc
)

SET(SQL_SHARED_SOURCES
  auth/auth_acls.cc
  auth/auth_common.cc
  auth/dynamic_privileges_impl.cc
  auth/dynamic_privilege_table.cc
  auth/acl_table_user.cc
  auth/sql_authentication.cc
  auth/sql_auth_cache.cc
  auth/sql_authorization.cc
  auth/sql_mfa.cc
  auth/sql_user_table.cc
  auth/sql_user.cc
  auth/partial_revokes.cc
  auth/password.cc
  auth/password_policy_service.cc
  auth/sql_security_ctx.cc
  auth/service_security_context.cc
  auto_thd.cc
  keyring_service.cc
  auth/roles.cc
  auth/role_tables.cc
  auth/sha2_password_common.cc
  auth/sha2_password.cc
  ssl_wrapper_service.cc
  bootstrap.cc
  check_stack.cc
  conn_handler/connection_handler_manager.cc
  clone_handler.cc
  create_field.cc
  current_thd.cc
  dd_sql_view.cc
  dd_sp.cc
  dd_table_share.cc
  debug_sync.cc
  default_values.cc
  derror.cc
  error_handler.cc
  field.cc
  field_conv.cc
  filesort.cc
  filesort_utils.cc
  aggregate_check.cc
  gstream.cc
  handler.cc
  histograms/equi_height.cc
  histograms/equi_height_bucket.cc
  histograms/histogram.cc
  histograms/singleton.cc
  histograms/value_map.cc
  hostname_cache.cc
  init.cc
  log_resource.cc
  item.cc
  item_buff.cc
  item_cmpfunc.cc
  item_create.cc
  item_func.cc
  item_gtid_func.cc
  item_pfs_func.cc
  item_json_func.cc
  item_regexp_func.cc
  item_row.cc
  item_strfunc.cc
  item_subselect.cc
  item_sum.cc
  window.cc
  item_timefunc.cc
  item_xmlfunc.cc
  item_inetfunc.cc
  iterators/basic_row_iterators.cc
  iterators/bka_iterator.cc

=== components/libminchassis/CMakeLists.txt ===
# Copyright (c) 2020, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

SET(LIBMINCHASSIS_SOURCES
  component_common.cc
  dynamic_loader.cc
  dynamic_loader_scheme_file.cc
  mc_psi_system_service.cc
  mc_rwlock_service.cc
  minimal_chassis.cc
  minimal_chassis_runtime_error_imp.cc
  my_metadata.cc
  my_ref_counted.cc
  mysql_component.cc
  mysql_service_implementation.cc
  registry.cc
  rwlock_scoped_lock.cc
)

ADD_LIBRARY(minchassis STATIC ${LIBMINCHASSIS_SOURCES})
ADD_DEPENDENCIES(minchassis GenError)
TARGET_LINK_LIBRARIES(minchassis ${CMAKE_DL_LIBS})

=== libmysql/authentication_ldap/CMakeLists.txt ===
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

#
# Configuration for building LDAP SASL Authentication Plugin (client-side)
#

# Skip it if disabled.
IF(NOT WITH_AUTHENTICATION_CLIENT_PLUGINS)
  MESSAGE(STATUS "Skipping the LDAP client authentication plugin")
  RETURN()
ENDIF()

# The client authentication plugin is part of the community build.
# Build it if we have found the necessary libraries.
IF(NOT SASL_FOUND OR NOT LDAP_FOUND)
  MESSAGE(WARNING "Skipping the LDAP client authentication plugin")
  RETURN()
ENDIF()

IF(FREEBSD AND KERBEROS_SYSTEM_LIBRARY)
  INCLUDE_DIRECTORIES(SYSTEM /usr/local/include)
ENDIF()

IF(FREEBSD AND SASL_INCLUDE_DIR)
  INCLUDE_DIRECTORIES(BEFORE SYSTEM ${SASL_INCLUDE_DIR})
ENDIF()

INCLUDE(CheckIncludeFiles)

# Several sasl_() functions are deprecated
IF(APPLE)
  STRING_APPEND(CMAKE_CXX_FLAGS " -Wno-deprecated-declarations")
ENDIF()

DISABLE_MISSING_PROFILE_WARNING()

IF(SASL_WITHOUT_KERBEROS)
  MESSAGE(WARNING "Bad custom SASL library")
  MESSAGE(STATUS
    "Building authentication_ldap_sasl_client WITHOUT Kerberos")
  UNSET(LDAP_KERBEROS_LIBS)
ELSEIF(KERBEROS_FOUND AND (NOT WIN32))
  MESSAGE(STATUS
    "Building authentication_ldap_sasl_client with Kerberos")
  IF(KERBEROS_INCLUDE_DIR)
    INCLUDE_DIRECTORIES(SYSTEM ${KERBEROS_INCLUDE_DIR})
  ENDIF()
  SET(AUTH_LDAP_KERBEROS_CC auth_ldap_kerberos.cc)
  # mysys is required to use my_free and my_strdup when getting
  # Kerberos user name.
  # Adding mysys only when build has Kerberos support
  SET(MY_SYS "mysys")
  SET(LDAP_KERBEROS_LIBS ${KERBEROS_LIBRARIES})
ELSE()
  MESSAGE(STATUS
    "Building authentication_ldap_sasl_client WITHOUT Kerberos")
  UNSET(LDAP_KERBEROS_LIBS)
ENDIF()

MYSQL_ADD_PLUGIN(authentication_ldap_sasl_client
  auth_ldap_sasl_client.cc
  auth_ldap_sasl_mechanism.cc
  ${AUTH_LDAP_KERBEROS_CC}
  log_client.cc
  LINK_LIBRARIES
  ${SASL_LIBRARY}
  ${LDAP_KERBEROS_LIBS}
  ${SSL_LIBRARIES}
  ${LIBDL}
  ${MY_SYS}
  CLIENT_ONLY
  MODULE_ONLY
  MODULE_OUTPUT_NAME "authentication_ldap_sasl_client")

# MYSQL_ADD_PLUGIN may have decided not to build it.
IF(NOT TARGET authentication_ldap_sasl_client)
  RETURN()
ENDIF()

IF(KERBEROS_FOUND AND (NOT WIN32))
  SET(PLUGIN_VERSION_FILE
    ${CMAKE_CURRENT_SOURCE_DIR}/authentication_ldap_sasl_client.ver)
  # Hide all symbols in mysys, to avoid ODR violations.
  # There is *one* visible symbol: _mysql_client_plugin_declaration_
  MY_TARGET_LINK_OPTIONS(authentication_ldap_sasl_client
    "LINKER:--version-script=${PLUGIN_VERSION_FILE}"
    )
ENDIF()

IF(LINUX_STANDALONE AND SASL_CUSTOM_LIBRARY)
  TARGET_COMPILE_DEFINITIONS(authentication_ldap_sasl_client
    PRIVATE SASL_CUSTOM_LIBRARY)
  ADD_DEPENDENCIES(authentication_ldap_sasl_client ${sasl_target})
ENDIF()

IF(LINUX_STANDALONE AND KERBEROS_CUSTOM_LIBRARY)
  ADD_DEPENDENCIES(authentication_ldap_sasl_client ${kerberos_target})
ENDIF()

IF(WIN32)
  GET_FILENAME_COMPONENT(SASL_DLL_NAME ${SASL_LIBRARY_DLL} NAME)
  GET_FILENAME_COMPONENT(SASL_SCRAM_PLUGIN_NAME "${SASL_SCRAM_PLUGIN}" NAME)

  MESSAGE(STATUS "SASL_INCLUDE_DIR  = ${SASL_INCLUDE_DIR}")
  MESSAGE(STATUS "SASL_LIBRARY_DLL  = ${SASL_LIBRARY_DLL}")
  MESSAGE(STATUS "SASL_SCRAM_PLUGIN = ${SASL_SCRAM_PLUGIN}")

  # Note that "libsasl.dll" and "saslSCRAM.dll" go into the "bin" directory
  # where "mysql.exe" and other client executables are located.
  INSTALL(FILES "${SASL_LIBRARY_DLL}"
          DESTINATION ${INSTALL_BINDIR}
          COMPONENT SharedLibraries)
  INSTALL(FILES "${SASL_SCRAM_PLUGIN}"
          DESTINATION ${INSTALL_BINDIR}
          COMPONENT SharedLibraries)

  # To run client executables that load the plug-in from the build tree we need
  # to copy the SASL library DLL and SASL SCRAM library DLL to the same
  # directory as the client executables.
  ADD_CUSTOM_COMMAND(TARGET authentication_ldap_sasl_client POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
      "${SASL_LIBRARY_DLL}"
      "${CMAKE_BINARY_DIR}/runtime_output_directory/${CMAKE_CFG_INTDIR}/${SASL_DLL_NAME}"
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
      "${SASL_SCRAM_PLUGIN}"
      "${CMAKE_BINARY_DIR}/runtime_output_directory/${CMAKE_CFG_INTDIR}/${SASL_SCRAM_PLUGIN_NAME}"
  )
  ADD_DEPENDENCIES(authentication_ldap_sasl_client mysqltest)

ENDIF()

=== plugin/semisync/CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

ADD_DEFINITIONS(-DMYSQL_SERVER)
ADD_DEFINITIONS(-DLOG_SUBSYSTEM_TAG="Repl")
ADD_DEFINITIONS(-DLOG_COMPONENT_TAG="semisync")
MSVC_CPPCHECK_DISABLE()

DISABLE_MISSING_PROFILE_WARNING()

MYSQL_ADD_PLUGIN(semisync_source
  semisync.cc
  semisync_source.cc
  semisync_source_ack_receiver.cc
  semisync_source_plugin.cc
  MODULE_ONLY
  MODULE_OUTPUT_NAME "semisync_source"
  VISIBILITY_HIDDEN
  LINK_LIBRARIES extra::rapidjson
  )

MYSQL_ADD_PLUGIN(semisync_replica
  semisync.cc
  semisync_replica.cc
  semisync_replica_plugin.cc
  MODULE_ONLY
  MODULE_OUTPUT_NAME "semisync_replica"
  VISIBILITY_HIDDEN
  LINK_LIBRARIES extra::rapidjson
  )

MYSQL_ADD_PLUGIN(semisync_master
  semisync.cc
  semisync_source.cc
  semisync_source_ack_receiver.cc
  semisync_source_plugin_old.cc
  MODULE_ONLY
  MODULE_OUTPUT_NAME "semisync_master"
  VISIBILITY_HIDDEN
  LINK_LIBRARIES extra::rapidjson
  )

MYSQL_ADD_PLUGIN(semisync_slave
  semisync.cc
  semisync_replica.cc
  semisync_replica_plugin_old.cc
  MODULE_ONLY
  MODULE_OUTPUT_NAME "semisync_slave"
  VISIBILITY_HIDDEN
  LINK_LIBRARIES extra::rapidjson
  )

=== router/src/CMakeLists.txt ===
# Copyright (c) 2015, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

ADD_SUBDIRECTORY(connection_pool)
ADD_SUBDIRECTORY(destination_status)
ADD_SUBDIRECTORY(harness)
ADD_SUBDIRECTORY(http)
ADD_SUBDIRECTORY(io)
ADD_SUBDIRECTORY(json_schema_embedder)
ADD_SUBDIRECTORY(keepalive)
ADD_SUBDIRECTORY(metadata_cache)
ADD_SUBDIRECTORY(mock_server)
ADD_SUBDIRECTORY(mysql_protocol)
ADD_SUBDIRECTORY(mysqlxmessages)
ADD_SUBDIRECTORY(openssl)
ADD_SUBDIRECTORY(plugin_info)
ADD_SUBDIRECTORY(protobuf)
ADD_SUBDIRECTORY(rest_api)
ADD_SUBDIRECTORY(rest_connection_pool)
ADD_SUBDIRECTORY(rest_metadata_cache)
ADD_SUBDIRECTORY(rest_router)
ADD_SUBDIRECTORY(rest_routing)
ADD_SUBDIRECTORY(router)
ADD_SUBDIRECTORY(routing)

# Directory layout after 'make install' is different.
# Create symlinks to ssl libraries for both: build and install layouts
IF (APPLE_WITH_CUSTOM_SSL)
  FILE(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/plugin_output_directory/mysqlrouter")

  ADD_CUSTOM_TARGET(link_openssl_dlls_for_install_mysqlrouter ALL
    COMMAND ${CMAKE_COMMAND} -E create_symlink
      "../../lib/${CRYPTO_VERSION}" "${CRYPTO_VERSION}"
    COMMAND ${CMAKE_COMMAND} -E create_symlink
      "../../lib/${OPENSSL_VERSION}" "${OPENSSL_VERSION}"
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/plugin_output_directory/mysqlrouter"

    BYPRODUCTS
    "${CMAKE_BINARY_DIR}/plugin_output_directory/mysqlrouter/${CRYPTO_VERSION}"
    "${CMAKE_BINARY_DIR}/plugin_output_directory/mysqlrouter/${OPENSSL_VERSION}"
  )

  ADD_DEPENDENCIES(mysqlrouter_all
    link_openssl_dlls_for_install_mysqlrouter)
  ADD_DEPENDENCIES(mysqlrouter_all
    link_openssl_dlls)

  INSTALL(FILES
    ${CMAKE_BINARY_DIR}/plugin_output_directory/mysqlrouter/${CRYPTO_VERSION}
    ${CMAKE_BINARY_DIR}/plugin_output_directory/mysqlrouter/${OPENSSL_VERSION}
    DESTINATION ${ROUTER_INSTALL_PLUGINDIR} COMPONENT Router
  )
ENDIF()

=== router/tests/CMakeLists.txt ===
# Copyright (c) 2015, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

INCLUDE_DIRECTORIES(SYSTEM ${GMOCK_INCLUDE_DIRS})

SET(helper_sources
  helpers/filesystem_utils.cc
  helpers/gtest_testname.cc
  helpers/mock_server_testutils.cc
  helpers/core_dumper.cc
  helpers/core_finder.cc
  helpers/process_manager.cc
  helpers/process_wrapper.cc
  helpers/router_component_clusterset.cc
  helpers/router_component_test.cc
  helpers/router_component_testutils.cc
  helpers/router_component_system_layout.cc
  helpers/router_test_helpers.cc
  helpers/script_generator.cc
  helpers/shared_server.cc
  helpers/tcp_port_pool.cc
  helpers/rest_api_testutils.cc
  helpers/rest_metadata_client.cc
)

IF(MY_COMPILER_IS_CLANG)
  STRING_APPEND(CMAKE_CXX_FLAGS " -Wno-deprecated")
ENDIF()

# TODO(sgunders): Remove when all GMock tests use MOCK_METHOD().
STRING(REPLACE "-Wsuggest-override" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

ADD_LIBRARY(routertest_helpers STATIC ${helper_sources})

TARGET_LINK_LIBRARIES(routertest_helpers harness-library router_lib
  rest_api_lib mock_server_rest_client)
TARGET_INCLUDE_DIRECTORIES(routertest_helpers
  PUBLIC
  helpers
  ${PROJECT_SOURCE_DIR}/src/harness/shared/include/
  )



ADD_SUBDIRECTORY(component)
ADD_SUBDIRECTORY(fuzzers)
ADD_SUBDIRECTORY(integration)

ADD_DEFINITIONS(
  -DCOMPONENT_TEST_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/component/data/")
ADD_DEFINITIONS(
  -DSSL_TEST_DATA_DIR="${CMAKE_SOURCE_DIR}/mysql-test/std_data/")

=== scripts/sys_schema/CMakeLists.txt ===
# Copyright (c) 2019, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA


SET(SYS_SCHEMA_SOURCES
  before_setup.sql

  init_priv.sql

  views/version.sql

  tables/sys_config.sql
  tables/sys_config_alter.sql
  tables/sys_config_data.sql

  triggers/sys_config_insert_set_user.sql
  triggers/sys_config_update_set_user.sql

  functions/extract_schema_from_file_name.sql
  functions/extract_table_from_file_name.sql
  functions/format_bytes.sql
  functions/format_path.sql
  functions/format_statement.sql
  functions/format_time.sql
  functions/list_add.sql
  functions/list_drop.sql
  functions/ps_is_account_enabled.sql
  functions/ps_is_consumer_enabled.sql
  functions/ps_is_instrument_default_enabled.sql
  functions/ps_is_instrument_default_timed.sql
  functions/ps_is_thread_instrumented.sql
  functions/ps_thread_id.sql
  functions/ps_thread_account.sql
  functions/ps_thread_stack.sql
  functions/ps_thread_trx_info.sql
  functions/quote_identifier.sql
  functions/sys_get_config.sql
  functions/version_major.sql
  functions/version_minor.sql
  functions/version_patch.sql
  
  views/i_s/innodb_buffer_stats_by_schema.sql
  views/i_s/x_innodb_buffer_stats_by_schema.sql
  views/i_s/innodb_buffer_stats_by_table.sql
  views/i_s/x_innodb_buffer_stats_by_table.sql
  views/i_s/schema_object_overview.sql
  views/i_s/schema_auto_increment_columns.sql
  views/i_s/x_schema_flattened_keys.sql
  views/i_s/schema_redundant_indexes.sql
  views/p_s/ps_check_lost_instrumentation.sql
  views/p_s/latest_file_io.sql
  views/p_s/x_latest_file_io.sql
  views/p_s/io_by_thread_by_latency.sql
  views/p_s/x_io_by_thread_by_latency.sql
  views/p_s/io_global_by_file_by_bytes.sql
  views/p_s/x_io_global_by_file_by_bytes.sql
  views/p_s/io_global_by_file_by_latency.sql
  views/p_s/x_io_global_by_file_by_latency.sql
  views/p_s/io_global_by_wait_by_bytes.sql
  views/p_s/x_io_global_by_wait_by_bytes.sql
  views/p_s/io_global_by_wait_by_latency.sql
  views/p_s/x_io_global_by_wait_by_latency.sql
  views/p_s/innodb_lock_waits.sql
  views/p_s/x_innodb_lock_waits.sql
  views/p_s/memory_by_user_by_current_bytes.sql
  views/p_s/x_memory_by_user_by_current_bytes.sql
  views/p_s/memory_by_host_by_current_bytes.sql
  views/p_s/x_memory_by_host_by_current_bytes.sql
  views/p_s/memory_by_thread_by_current_bytes.sql
  views/p_s/x_memory_by_thread_by_current_bytes.sql
  views/p_s/memory_global_by_current_bytes.sql
  views/p_s/x_memory_global_by_current_bytes.sql
  views/p_s/memory_global_total.sql
  views/p_s/x_memory_global_total.sql
  views/p_s/schema_index_statistics.sql
  views/p_s/x_schema_index_statistics.sql
  views/p_s/x_ps_schema_table_statistics_io.sql
  views/p_s/schema_table_statistics.sql
  views/p_s/x_schema_table_statistics.sql
  views/p_s/schema_table_statistics_with_buffer.sql
  views/p_s/x_schema_table_statistics_with_buffer.sql
  views/p_s/schema_tables_with_full_table_scans.sql
  views/p_s/x_schema_tables_with_full_table_scans.sql
  views/p_s/schema_unused_indexes.sql
  views/p_s/schema_table_lock_waits.sql
  views/p_s/x_schema_table_lock_waits.sql
  views/p_s/statement_analysis.sql
  views/p_s/x_statement_analysis.sql
  views/p_s/statements_with_errors_or_warnings.sql
  views/p_s/x_statements_with_errors_or_warnings.sql
  views/p_s/statements_with_full_table_scans.sql
  views/p_s/x_statements_with_full_table_scans.sql
  views/p_s/x_ps_digest_avg_latency_distribution.sql
  views/p_s/x_ps_digest_95th_percentile_by_avg_us.sql
  views/p_s/statements_with_runtimes_in_95th_percentile.sql
  views/p_s/x_statements_with_runtimes_in_95th_percentile.sql
  views/p_s/statements_with_sorting.sql
  views/p_s/x_statements_with_sorting.sql
  views/p_s/statements_with_temp_tables.sql
  views/p_s/x_statements_with_temp_tables.sql
  views/p_s/user_summary_by_file_io_type.sql
  views/p_s/x_user_summary_by_file_io_type.sql
  views/p_s/user_summary_by_file_io.sql
  views/p_s/x_user_summary_by_file_io.sql
  views/p_s/user_summary_by_statement_type.sql
  views/p_s/x_user_summary_by_statement_type.sql
  views/p_s/user_summary_by_statement_latency.sql
  views/p_s/x_user_summary_by_statement_latency.sql
  views/p_s/user_summary_by_stages.sql
  views/p_s/x_user_summary_by_stages.sql
  views/p_s/user_summary.sql
  views/p_s/x_user_summary.sql
  views/p_s/host_summary_by_file_io_type.sql
  views/p_s/x_host_summary_by_file_io_type.sql
  views/p_s/host_summary_by_file_io.sql
  views/p_s/x_host_summary_by_file_io.sql
  views/p_s/host_summary_by_statement_type.sql
  views/p_s/x_host_summary_by_statement_type.sql
  views/p_s/host_summary_by_statement_latency.sql
  views/p_s/x_host_summary_by_statement_latency.sql
  views/p_s/host_summary_by_stages.sql
  views/p_s/x_host_summary_by_stages.sql
  views/p_s/host_summary.sql
  views/p_s/x_host_summary.sql
  views/p_s/wait_classes_global_by_avg_latency.sql
  views/p_s/x_wait_classes_global_by_avg_latency.sql
  views/p_s/wait_classes_global_by_latency.sql
  views/p_s/x_wait_classes_global_by_latency.sql
  views/p_s/waits_by_user_by_latency.sql
  views/p_s/x_waits_by_user_by_latency.sql
  views/p_s/waits_by_host_by_latency.sql
  views/p_s/x_waits_by_host_by_latency.sql
  views/p_s/waits_global_by_latency.sql
  views/p_s/x_waits_global_by_latency.sql
  views/p_s/metrics.sql
  views/p_s/processlist.sql
  views/p_s/x_processlist.sql
  views/p_s/sessions.sql
  views/p_s/x_sessions.sql
  views/p_s/session_ssl_status.sql

  procedures/create_synonym_db.sql
  procedures/execute_prepared_stmt.sql
  procedures/diagnostics.sql
  procedures/ps_statement_avg_latency_histogram.sql
  procedures/ps_trace_statement_digest.sql
  procedures/ps_trace_thread.sql
  procedures/ps_setup_disable_background_threads.sql
  procedures/ps_setup_disable_consumer.sql
  procedures/ps_setup_disable_instrument.sql
  procedures/ps_setup_disable_thread.sql
  procedures/ps_setup_enable_background_threads.sql
  procedures/ps_setup_enable_consumer.sql
  procedures/ps_setup_enable_instrument.sql
  procedures/ps_setup_enable_thread.sql
  procedures/ps_setup_reload_saved.sql
  procedures/ps_setup_reset_to_default.sql
  procedures/ps_setup_save.sql
  procedures/ps_setup_show_disabled.sql
  procedures/ps_setup_show_disabled_consumers.sql
  procedures/ps_setup_show_disabled_instruments.sql
  procedures/ps_setup_show_enabled.sql
  procedures/ps_setup_show_enabled_consumers.sql
  procedures/ps_setup_show_enabled_instruments.sql
  procedures/ps_truncate_all_tables.sql
  procedures/statement_performance_analyzer.sql
  procedures/table_exists.sql

  after_setup.sql
  )


ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ALL_SYS_SCHEMA.sql
  COMMAND ${CMAKE_COMMAND}
  -D "OUTPUT_DIR=${CMAKE_CURRENT_BINARY_DIR}"
  -D "SYS_SCHEMA_SOURCES=${SYS_SCHEMA_SOURCES}"
  -P ${CMAKE_CURRENT_SOURCE_DIR}/run_gensysschema.cmake
  DEPENDS ${SYS_SCHEMA_SOURCES}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMENT "Generating Sys Schema SQL code"
  VERBATIM
)

MY_ADD_CUSTOM_TARGET(all_sys_schema
  DEPENDS ALL_SYS_SCHEMA.sql)


ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sql_commands.h
  COMMAND comp_sql
  mysql_sys_schema
  ${CMAKE_CURRENT_BINARY_DIR}/ALL_SYS_SCHEMA.sql
  sql_commands.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql all_sys_schema
  ${CMAKE_CURRENT_BINARY_DIR}/ALL_SYS_SCHEMA.sql
  VERBATIM
)

MY_ADD_CUSTOM_TARGET(sql_commands
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/sql_commands.h)

MY_ADD_CUSTOM_TARGET(GenSysSchemaC
  ALL
  DEPENDS comp_sql sql_commands
  COMMENT "Generating Sys Schema C code"
)

IF(NOT WITHOUT_SERVER)
  MY_ADD_CUSTOM_TARGET(GenSysSchema
    ALL
    DEPENDS sql_commands
  )
ENDIF()

=== storage/archive/CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

MSVC_CPPCHECK_DISABLE()

MYSQL_ADD_PLUGIN(archive azio.cc ha_archive.cc
  DEFAULT_LEGACY_ENGINE
  STORAGE_ENGINE
  LINK_LIBRARIES extra::rapidjson ext::zlib
)
# Exclude archive from PGO on Windows to avoid linker error LNK1248
EXCLUDE_FROM_MSVC_PGO(archive)

=== debian/changelog ===
mysql-8.0 (8.0.42-0ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: Update to 8.0.42 to fix security issues
    - CVE-2025-21574, CVE-2025-21575, CVE-2025-21577, CVE-2025-21579,
      CVE-2025-21580, CVE-2025-21581, CVE-2025-21584, CVE-2025-21585,
      CVE-2025-30681, CVE-2025-30682, CVE-2025-30683, CVE-2025-30684,
      CVE-2025-30685, CVE-2025-30687, CVE-2025-30688, CVE-2025-30689,
      CVE-2025-30693, CVE-2025-30695, CVE-2025-30696, CVE-2025-30699,
      CVE-2025-30703, CVE-2025-30704, CVE-2025-30705, CVE-2025-30715,
      CVE-2025-30721, CVE-2025-30722

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 25 Apr 2025 13:19:53 -0400

mysql-8.0 (8.0.41-0ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: Update to 8.0.41 to fix security issues
    - CVE-2025-21490, CVE-2025-21491, CVE-2025-21497, CVE-2025-21500,
      CVE-2025-21501, CVE-2025-21503, CVE-2025-21505, CVE-2025-21519,
      CVE-2025-21522, CVE-2025-21523, CVE-2025-21529, CVE-2025-21540,
      CVE-2025-21546, CVE-2025-21555, CVE-2025-21559

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 23 Jan 2025 07:33:41 -0500

mysql-8.0 (8.0.40-0ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: Update to 8.0.40 to fix security issues
    - CVE-2024-21193, CVE-2024-21194, CVE-2024-21196, CVE-2024-21197,
      CVE-2024-21198, CVE-2024-21199, CVE-2024-21201, CVE-2024-21212,
      CVE-2024-21213, CVE-2024-21219, CVE-2024-21230, CVE-2024-21231,
      CVE-2024-21236, CVE-2024-21237, CVE-2024-21239, CVE-2024-21241

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 23 Oct 2024 08:15:00 -0400

mysql-8.0 (8.0.39-0ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: Update to 8.0.39 to fix security issues
    - CVE-2024-20996, CVE-2024-21125, CVE-2024-21127, CVE-2024-21129,
      CVE-2024-21130, CVE-2024-21134, CVE-2024-21142, CVE-2024-21162,
      CVE-2024-21163, CVE-2024-21165, CVE-2024-21171, CVE-2024-21173,
      CVE-2024-21177, CVE-2024-21179, CVE-2024-21185

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 24 Jul 2024 07:10:05 -0400

mysql-8.0 (8.0.37-0ubuntu0.20.04.3) focal-security; urgency=medium


  * SECURITY UPDATE: Update to 8.0.37 to fix security issues
    - CVE-2024-20994, CVE-2024-20998, CVE-2024-21000, CVE-2024-21008,
      CVE-2024-21009, CVE-2024-21013, CVE-2024-21047, CVE-2024-21054,
      CVE-2024-21060, CVE-2024-21062, CVE-2024-21069, CVE-2024-21087,
      CVE-2024-21096, CVE-2024-21102
    - debian/patches/revert_faster_tls_model.patch: updated for new
      version.
    - debian/patches/disable_test_riscv64_ftbfs.patch: disable a test that
      FTBFS on riscv64.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 22 May 2024 12:16:04 -0400

mysql-8.0 (8.0.36-0ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: Update to 8.0.36 to fix security issues
    - CVE-2024-20960, CVE-2024-20961, CVE-2024-20962, CVE-2024-20963,
      CVE-2024-20964, CVE-2024-20965, CVE-2024-20966, CVE-2024-20967,
      CVE-2024-20969, CVE-2024-20970, CVE-2024-20971, CVE-2024-20972,
      CVE-2024-20973, CVE-2024-20974, CVE-2024-20976, CVE-2024-20977,
      CVE-2024-20978, CVE-2024-20981, CVE-2024-20982, CVE-2024-20983,
      CVE-2024-20984, CVE-2024-20985
    - debian/patches/revert_faster_tls_model.patch: updated for new
      version.
  * Removed patch no longer needed with 8.0.35+
    - debian/patches/revert-be8348a7.patch: fix crash on startup on armhf
  * Enable test suite on armhf (LP: #2024276)
    - debian/rules: check for failures in armhf tests
    - debian/patches/suppress_armhf_test_warning.patch: suppress warning
      about the CYCLE timer not being available on armhf. (LP: #1999075)
    - debian/patches/disable_64bits_time_armhf.patch: specify armhf doesn't
      have a 64bit timer in mysql-test/include/have_64bits_time.inc.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 17 Jan 2024 15:13:42 -0500

mysql-8.0 (8.0.35-0ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: Update to 8.0.35 to fix security issues
    - CVE-2023-22032, CVE-2023-22059, CVE-2023-22064, CVE-2023-22066,
      CVE-2023-22068, CVE-2023-22070, CVE-2023-22078, CVE-2023-22079,
      CVE-2023-22084, CVE-2023-22092, CVE-2023-22097, CVE-2023-22103,
      CVE-2023-22112, CVE-2023-22114

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 25 Oct 2023 13:34:23 -0400

mysql-8.0 (8.0.34-0ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: Update to 8.0.34 to fix security issues
    - CVE-2023-22005, CVE-2023-22008, CVE-2023-22033, CVE-2023-22038,
      CVE-2023-22046, CVE-2023-22048, CVE-2023-22053, CVE-2023-22054,
      CVE-2023-22056, CVE-2023-22057, CVE-2023-22058
    - d/p/fix_expired_date_in_test.patch: removed, no longer needed with
      new version.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 21 Jul 2023 09:03:20 -0400

mysql-8.0 (8.0.33-0ubuntu0.20.04.4) focal; urgency=medium

  * d/t/upstream: Ignore upstream tests due to s390x failure (LP: #2020910)
    Due to slight variation in the optimization of join statements on s390x, a
    few upstream tests fail as they show a cost slightly higher than expected.
    The tests include main.subquery_sj_all_bka_nobnl and
    main.subquery_sj_mat_bka_nobnl

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 14 Jun 2023 12:45:13 -0700

mysql-8.0 (8.0.33-0ubuntu0.20.04.3) focal; urgency=medium

  * d/p/mysql_secure_installation-remove-root-pw-creation.patch: Fix
    mysql_secure_installation by removing root password creation (LP: #1980466)

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 08 Jun 2023 07:53:54 -0700

mysql-8.0 (8.0.33-0ubuntu0.20.04.2) focal-security; urgency=medium

  * Fix crash on startup on armhf (LP: #2019203)
    - debian/patches/revert-be8348a7.patch: revert upstream commit.
  * Fix expired date in main.derived_condition_pushdown test
    - debian/patches/fix_expired_date_in_test.patch: update expired date.



=== debian/control ===
Source: mysql-8.0
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Norbert Tretkowski <norbert@tretkowski.de>,
           Clint Byrum <clint@ubuntu.com>,
           James Page <jamespage@debian.org>,
           Robie Basak <robie@justgohome.co.uk>,
           Lars Tangvald <lars.tangvald@oracle.com>
Build-Depends: bison,
               chrpath,
               cmake,
               debhelper (>= 9.20160709),
               dh-apparmor,
               dpkg-dev (>= 1.16.1~),
               libaio-dev[linux-any],
               libedit-dev,
               libevent-dev,
               libexpect-perl,
               libicu-dev,
               libjson-perl,
               liblz4-dev (>= 0.0~r131),
               libmecab-dev,
               libncurses5-dev (>= 5.0-6),
               libnuma-dev [amd64 arm64 i386 mips mips64el mipsel powerpc ppc64el],
               libssl-dev,
               libwrap0-dev (>= 7.6-8.3),
               lsb-release,
               lz4,
               perl,
               pkg-config,
               po-debconf,
               psmisc,
               rapidjson-dev,
               unzip,
               zlib1g-dev (>= 1:1.1.3-5)
Standards-Version: 3.9.8
Homepage: http://dev.mysql.com/
Vcs-Git: https://salsa.debian.org/mariadb-team/mysql.git -b mysql-8.0/debian/master
Vcs-Browser: https://salsa.debian.org/mariadb-team/mysql
XS-Testsuite: autopkgtest

Package: libmysqlclient21
Section: libs
Architecture: any
Depends: mysql-common (>= 5.5), ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: MySQL database client library
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the client library.

Package: libmysqlclient-dev
Architecture: any
Section: libdevel
Depends: libmysqlclient21 (= ${binary:Version}),
         libssl-dev,
         zlib1g-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libmysqld-dev (<< 8.0)
Replaces: libmysqld-dev (<< 8.0)
Description: MySQL database development files
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes development libraries and header files.

Package: mysql-client-core-8.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: virtual-mysql-client-core
Conflicts: mariadb-client-10.1,
           mariadb-client-10.3,
           mariadb-client-core-10.1,
           mariadb-client-core-10.3,
           mysql-client-5.7,
           mysql-client-core-5.7,
           virtual-mysql-client-core
Description: MySQL database core client binaries
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the core client files, as used by Akonadi.

Package: mysql-client-8.0
Architecture: any
Depends: debianutils (>=1.6),
         mysql-client-core-8.0,
         mysql-common (>= 5.5),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: virtual-mysql-client
Conflicts: mariadb-client-10.1,
           mariadb-client-10.3,
           mysql-client-5.7,
           virtual-mysql-client
Description: MySQL database client binaries
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the client binaries and the additional tool
 mysqlreport.

Package: mysql-server-core-8.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: virtual-mysql-server-core
Conflicts: mariadb-server-10.1,
           mariadb-server-10.3,
           mariadb-server-core-10.1,
           mariadb-server-core-10.3,
           mysql-server-5.7,
           mysql-server-core-5.7,
           virtual-mysql-server-core
Description: MySQL database server binaries
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the server binaries but doesn't contain all the
 infrastructure needed to setup system databases.

Package: mysql-server-8.0
Architecture: any
Recommends: libhtml-template-perl, mecab-ipadic-utf8
Suggests: mailx, tinyca
Pre-Depends: adduser (>= 3.40), debconf, mysql-common (>= 5.5)
Depends: lsb-base (>= 3.0-10),
         mysql-client-8.0 (>= ${binary:Version}),
         mysql-common (>= 5.8+1.0.4~),
         mysql-server-core-8.0 (= ${binary:Version}),
         passwd,
         perl:any (>= 5.6),
         psmisc,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: virtual-mysql-server
Conflicts: mariadb-server-10.1,
           mariadb-server-10.3,
           mysql-server-5.7,
           virtual-mysql-server
Description: MySQL database server binaries and system database setup
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package contains all the infrastructure needed to setup system
 databases.

Package: mysql-server
Architecture: all
Depends: mysql-server-8.0, ${misc:Depends}
Description: MySQL database server (metapackage depending on the latest version)
 This is an empty package that depends on the current "best" version of
 mysql-server (currently mysql-server-8.0), as determined by the MySQL
 maintainers. Install this package if in doubt about which MySQL
 version you need. That will install the version recommended by the
 package maintainers.
 .
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.

Package: mysql-client
Architecture: all
Depends: mysql-client-8.0, ${misc:Depends}
Description: MySQL database client (metapackage depending on the latest version)
 This is an empty package that depends on the current "best" version of
 mysql-client (currently mysql-client-8.0), as determined by the MySQL
 maintainers.  Install this package if in doubt about which MySQL version
 you want, as this is the one considered to be in the best shape by the
 Maintainers.

Package: mysql-testsuite
Architecture: all
Depends: mysql-testsuite-8.0, ${misc:Depends}
Description: MySQL regression tests
 This is an empty package that depends on the current "best" version of
 mysql-testsuite (currently mysql-testsuite-8.0), as determined by the
 MySQL maintainers.  Install this package if in doubt about which MySQL
 version you want, as this is the one we consider to be in the best shape.

Package: mysql-testsuite-8.0
Architecture: any
Depends: libjson-perl,
         lz4,
         mysql-client-8.0 (= ${binary:Version}),
         mysql-server-8.0 (= ${binary:Version}),
         unzip,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: virtual-mysql-testsuite
Conflicts: mariadb-testsuite-10.1,
           mariadb-testsuite-10.3,
           mysql-testsuite-5.7,
           virtual-mysql-testsuite
Description: MySQL 8.0 testsuite
 MySQL is a fast, stable, and true multi-user, multi-threaded SQL database
 server.  SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the MySQL testsuite.

Package: mysql-source-8.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: MySQL source
 MySQL is a fast, stable, and true multi-user, multi-threaded SQL database
 server.  SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the MySQL source code as configured before building
 - but after the arch specific configuration. This is currently required for
 building plugins.

Package: mysql-router
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: route connections from MySQL clients to MySQL servers
 MySQL Router is part of InnoDB cluster, and is lightweight middleware that
 provides transparent routing between your application and back-end MySQL
 servers. It can be used for a wide variety of use cases, such as providing
 high availability and scalability by effectively routing database traffic to
 appropriate back-end MySQL servers. The pluggable architecture also enables
 developers to extend MySQL Router for custom use cases.
 .
 Since MySQL Router is clustering software and needs to be configured and
 managed across an entire cluster, packaging cannot manage it for you. This
 package supplies the binary build only, ready for manual configuration.
Homepage: https://dev.mysql.com/doc/mysql-router/8.0/en/

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# enable Debian Hardening
# see: https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ARCH_OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
BUILDDIR := builddir
builddir = $(BUILDDIR)
DEBVERSION := $(shell dpkg-parsechangelog | awk '/^Version: / { print $$2 }' | sed 's/^.*-//' )
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_SYSTEM)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_SOURCE_PACKAGE ?= $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION ?= $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION ?= $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION ?= $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_UPSTREAM_VERSION_MAJOR_MINOR := $(shell echo $(DEB_UPSTREAM_VERSION) | sed -r -n 's/^([0-9]+\.[0-9]+).*/\1/p')
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DISTRIBUTION := $(shell lsb_release -i -s)
EXPORTED_SOURCE_TARBALL := debian/mysql-source-8.0.tar.gz
TMP := $(CURDIR)/debian/tmp/
NUMJOBS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
TESTJOBS=$(NUMJOBS)
# Some tests will fail on platforms that are not tested by upstream
ifneq (,$(filter $(ARCH), amd64 i386 armhf))
    TESTSUITE_FAIL_CMD:=exit 1
else
    TESTSUITE_FAIL_CMD:=true
endif

ifeq (,$(NUMJOBS))
	NUMJOBS=1
endif

# Disable parallel builds on arm64
PARALLEL_BUILDS = --parallel
ifneq (,$(filter $(DEB_HOST_ARCH),arm64))
	PARALLEL_BUILDS = --no-parallel
	NUMJOBS=1
endif

# In Ubuntu RapidJSON is in the universe repo, so we instead use the bundled headers
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	RAPIDJSONVAR = "bundled"
else
	RAPIDJSONVAR = "system"
endif

MAKEFLAGS += -j $(NUMJOBS)

# The below system setting constrains how many servers can be run in parallel
# A server with default config needs a bit over 5300 slots, so we assume 6000 to be sure
AIOMAX := $(shell cat /proc/sys/fs/aio-max-nr)
AIOPER := 6000
PARMAX := $(shell echo $$(( $(AIOMAX)/$(AIOPER))))

ifeq ($(shell test $(TESTJOBS) -gt $(PARMAX); echo $$?),0)
	TESTJOBS:=$(shell echo $(PARMAX) )
endif

export MYSQL_BUILD_CC=$(DEB_HOST_GNU_TYPE)-gcc
export MYSQL_BUILD_CXX=$(DEB_HOST_GNU_TYPE)-g++

# The full upstream test suite takes a very long time to run, so we run
# only the main test suite unless fulltest is specified.
ifeq ($(findstring fulltest,$(DEB_BUILD_OPTIONS)),)
    MTR_SUITE=--suite=main
endif


override_dh_auto_clean:
	@echo "RULES.$@"
	dh_testdir 
	dh_testroot
	[ ! -d mysql-test/var ] || rm -rf mysql-test/var
	rm -rf $(BUILDDIR)
	debconf-updatepo
	rm -f $(EXPORTED_SOURCE_TARBALL)

override_dh_prep: 

override_dh_auto_configure: configure-stamp


configure-stamp:
	@echo "RULES.$@"
	dh_testdir
	( test -d $(builddir) || mkdir $(builddir) ) && cd $(builddir) && \
	sh -c  'PATH=$${MYSQL_BUILD_PATH:-"/bin:/usr/bin"} \
		CC=$${MYSQL_BUILD_CC:-gcc} \
		CXX=$${MYSQL_BUILD_CXX:-g++} \
		cmake -DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DMYSQL_UNIX_ADDR=/var/run/mysqld/mysqld.sock \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_CONFIG=mysql_release \
		-DWITH_LIBWRAP=OFF \
		-DWITH_LZ4=system \
		-DWITH_EDITLINE=system \
		-DWITH_LIBEVENT=system \
		-DWITH_SSL=system \
		-DWITH_MECAB=system \
		-DWITH_ICU=system \
		-DWITH_BOOST=../boost \
		-DWITH_RAPIDJSON=$(RAPIDJSONVAR) \
		-DCOMPILATION_COMMENT="($(DISTRIBUTION))" \
		-DMYSQL_SERVER_SUFFIX="-$(DEBVERSION)" \
		-DINSTALL_LAYOUT=DEB \
		-DINSTALL_DOCDIR=share/mysql/docs \
		-DINSTALL_DOCREADMEDIR=share/mysql \
		-DINSTALL_INCLUDEDIR=include/mysql \
		-DINSTALL_INFODIR=share/mysql/docs \
		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
		-DINSTALL_MANDIR=share/man \
		-DINSTALL_MYSQLSHAREDIR=share/mysql \
		-DINSTALL_MYSQLTESTDIR=lib/mysql-test \
		-DINSTALL_PLUGINDIR=lib/mysql/plugin \
		-DINSTALL_SBINDIR=sbin \
		-DINSTALL_SCRIPTDIR=bin \
		-DINSTALL_SUPPORTFILESDIR=share/mysql \
		-DSYSCONFDIR=/etc/mysql \
		-DWITH_EMBEDDED_SERVER=ON \
		-DWITH_ARCHIVE_STORAGE_ENGINE=ON \
		-DWITH_BLACKHOLE_STORAGE_ENGINE=ON \
		-DWITH_FEDERATED_STORAGE_ENGINE=ON \
		-DWITH_INNODB_MEMCACHED=1 \
		-DWITH_EXTRA_CHARSETS=all \
		-DROUTER_INSTALL_LIBDIR=lib/mysql-router \
		-DWITH_FIDO=bundled \
		..'
	touch $@

override_dh_auto_build: build-stamp

# $(EXPORTED_SOURCE_TARBALL) must be built before the builds commence, since
# the builds change some of the files picked up by this tar invocation, and
# this can race against tar with an error like "tar:
# ./builddir-pic/strings/CMakeFiles/strings.dir: file changed as we read it".
# So define the rule for building it here, and have the build rules depend on
# it.
$(EXPORTED_SOURCE_TARBALL):
	GZIP=-n tar -zcf $(EXPORTED_SOURCE_TARBALL) \
	    --exclude=debian . \
	    --transform="s,^\./,mysql-8.0/,"

build-stamp: $(EXPORTED_SOURCE_TARBALL)
	@echo "RULES.$@"
	cd $(builddir) && $(MAKE)
	touch $@

override_dh_auto_test:
	@echo "RULES.$@"
ifeq ($(ARCH_OS),hurd)
	# Tests not fully working under Hurd, see
	# http://bugs.mysql.com/bug.php?id=64685. Run unit tests only.
	cd $(builddir) && $(MAKE) test || $(TESTSUITE_FAIL_CMD) ;
else
	touch $(builddir)/mysql-test/skiplist
	# Tests that are known to be unstable on all platforms are skipped
	# http://bugs.mysql.com/bug.php?id=83340
	echo "main.xa_prepared_binlog_off	: BUG#00000 - unstable test" >> $(builddir)/mysql-test/skiplist
	echo "main.mysql_client_test		: BUG#100274 - unstable test" >> $(builddir)/mysql-test/skiplist
	echo "main.type_float			: BUG#92375 - fails on ppc64el. Ref https://bugs.mysql.com/bug.php?id=92375" >> $(builddir)/mysql-test/skiplist
	echo "main.type_newdecimal		: BUG#92375 - Same as above" >> $(builddir)/mysql-test/skiplist
	echo "main.type_ranges			: BUG#92375 - Same as above" >> $(builddir)/mysql-test/skiplist
	# https://bugs.mysql.com/bug.php?id=86608
	echo "main.mysqlpump_basic		: BUG#00000 - needs openssl with zlib" >> $(builddir)/mysql-test/skiplist
	# Test is broken for 32bit. Fixed upstream, so remove in 8.0.12+
	echo "main.window_functions_explain	: BUG#00000 -  broken on i386" >> $(builddir)/mysql-test/skiplist
	# New test in 8.0.26, needs investigation
	echo "main.slow_log			: BUG#00000 -  broken" >> $(builddir)/mysql-test/skiplist
	# Test is broken for 32bit.
	echo "main.index_merge_myisam		: BUG#00000 -  broken on i386" >> $(builddir)/mysql-test/skiplist

	# Skip replication tests since they are timing sensitive and may
	# result in false positives.
	cd $(builddir)/mysql-test && ./mtr --suite-timeout=600 --testcase-timeout=60 --report-unstable-tests --parallel=$(TESTJOBS) --skip-rpl $(MTR_SUITE) --force --skip-test-list=./skiplist || $(TESTSUITE_FAIL_CMD) ;
endif

override_dh_auto_install: auto_install-stamp

auto_install-stamp:
	@echo "RULES.$@"
	dh_testdir
	dh_testroot
	# make install (trailing slash needed for innobase)
	cd $(builddir) && $(MAKE) install DESTDIR=$(TMP)/
	# After installing, remove rpath to make lintian happy.
	set +e; \
	find ./debian/tmp/ -type f -print0 \
		| xargs -0 --no-run-if-empty chrpath -k 2>/dev/null \
		| fgrep RPATH= \
		| cut -d: -f 1 \
		| xargs --no-run-if-empty chrpath -d; \
	set -e
	install -d -m 0755 -o root -g root $(TMP)/usr/lib/mysql
	mkdir -p $(TMP)/usr/share/doc/mysql-server-8.0
	nm -n $(BUILDDIR)/bin/mysqld |gzip -n -9 > $(TMP)/usr/share/doc/mysql-server-8.0/mysqld.sym.gz
	# This seems to be the only safe place to fix permissions issues
	# not handled by dh_fixperms.
	install -m 0755 debian/additions/echo_stderr $(TMP)/usr/share/mysql/
	mkdir -p $(TMP)/etc/mysql
	install -m 0755 debian/additions/debian-start $(TMP)/etc/mysql/
	install -m 0644 debian/additions/debian_create_root_user.sql $(TMP)/usr/share/mysql/

=== debian/tests/control ===
Tests: smoke
Depends: mysql-server-8.0
Restrictions: allow-stderr needs-root breaks-testbed

Tests: upstream
Depends: mysql-testsuite-8.0, libexpect-perl
Restrictions: allow-stderr breaks-testbed

=== debian/watch ===
version=3
opts=\
downloadurlmangle=s/\/downloads\/gpg\/?\?file=(mysql-boost-([\d\.]*).tar.gz)/\/get\/Downloads\/MySQL-8.0\/$1/,pgpsigurlmangle=s/\/get\/Downloads\/MySQL-8.0\/(mysql-boost-([\d\.]*).tar.gz)/\/downloads\/gpg\/?file=$1/,filenamemangle=s/\/downloads\/gpg\/?\?file=mysql\-boost\-([\d\.]*)\.tar\.gz/mysql-boost-$1.tar.gz/ \
http://dev.mysql.com/downloads/mysql/8.0.html?os=src /downloads/gpg/\?file=mysql-boost-([\d\.]*).tar.gz
